#include <cstdio>
#include <string>
#include <vector>
#include <ctime>

using std::string;
using std::vector;
using std::FILE;

class S3M
{
    string name;
    unsigned flags, version, ffi;
    unsigned char globalvolume;
    unsigned char cmdA, cmdT;
    unsigned char mastervolume;
    bool stereo;
    unsigned char ultraclick;
    unsigned char panflags;
    unsigned char chansets[32];
    unsigned char pansets[32];
    vector<unsigned char> orders;
    
    class pattern : public vector<unsigned char>
    {
    public:
    	pattern() : oldparaptr(0) { }
    	pattern(unsigned n) : vector<unsigned char> (n), oldparaptr(0) { }
        unsigned oldparaptr;
    };
    
    vector<pattern> patterns;
    class instrument
    {
    public:
    	unsigned oldparaptr;
    	
        unsigned char type;
        string filename;
        unsigned char data[32];
        string name;
        vector<unsigned char> audio;
    public:
        instrument() { Clear(); }
        void Clear();
    };
    vector<instrument> instrus;
    
    static unsigned readword(FILE *fp);
    static void writeword(FILE *fp, unsigned w);
    static void newpara(FILE *fp);
    bool ok;
public:
	S3M();
    S3M(const string &fn) : ok(Load(fn)) { }
    S3M(FILE *fp = NULL) : ok(fp ? Load(fp) : false) { }
    const bool isok() const { return ok; }
    bool Load(const string &fn)
    {
        bool valid = false;
        FILE *fp = fopen(fn.c_str(), "rb");
        if(fp) { valid = Load(fp); fclose(fp); }
        ok = valid;
        return valid;
    }
    bool Load(FILE *fp);
    void Save(const string &fn);
    void Save(FILE *fp);
    void Copyrite(time_t mtime, time_t atime);
    void Dump() const;
    
    const string &getname() const { return name; }
};
